#include <unistd.h>
#include <io.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <allegro.h>
#include "ymw.h"
#include "mem.h"
#include "SpellCheck.h"

char *mspbuf;

char *spell_check_string( char *data )
{
    FILE *fh;
    char fname[0x1000], fname2[0x1000];
    char *ret;
    char *oret;
    char cpath[512];

    if( strlen( data ) < 1 ){
      ret = malloc( 1 );
      ret[0] = '\0';
      return ret;
      }

    getwd( cpath );

    strcpy( fname, ".\\tmp" );

    strcpy( fname2, ".\\res\\ispell.exe -x -d.\\res\\eng -p.\\res\\usr_dict ");
    strcat( fname2, fname );

/*
    strcpy( fname, cpath );
    strcat( fname, "/tmp" );

    strcpy( fname2, cpath );
    strcat( fname2, "/res/ispell.exe -x -f");
    strcat( fname2, cpath );
    strcat( fname2, "/res/eng -p");
    strcat( fname2, cpath );
    strcat( fname2, "/res/usr_dict ");
    strcat( fname2, fname );
*/
    fh = fopen( fname, "wt" );
    fprintf( fh, "%s", data );
    fclose( fh );

    system( fname2 );

    if( (fh = fopen( fname, "rt" )) == NULL )
      return NULL;

    ret = mspbuf;
    if( !ret )
      return NULL;

    memset( ret, 0, 2*RDSIZE );

    oret = ret;
    do{
      fread( ret++, 1, 1, fh );
      } while( !feof(fh) );
    ret[-1] = '\0';
    fclose( fh );

    unlink( fname );

    return oret;
}

int spell_check_exd( EXD *exd )
{
    char *tmp;

    tmp = spell_check_string( exd->keywords );
    if( tmp ){
      memset( exd->keywords, 0, NAMESIZE );
      strcpy( exd->keywords, tmp );
      }

    tmp = spell_check_string( exd->desc );
    if( tmp ){
      memset( exd->desc, 0, RDSIZE );
      strcpy( exd->desc, tmp );
      }

    return 0;
}

int spell_check_door( DOOR *door )
{
    char *tmp;

    tmp = spell_check_string( door->keywords );
    if( tmp ){
      memset( door->keywords, 0, NAMESIZE );
      strcpy( door->keywords, tmp );
      }

    tmp = spell_check_string( door->desc );
    if( tmp ){
      memset( door->desc, 0, RDSIZE );
      strcpy( door->desc, tmp );
      }

    return 0;
}

int spell_check_room( ROOM *room )
{
    int j;
    char *tmp;

    tmp = spell_check_string( room->title );
    if( tmp ){
      memset( room->title, 0, NAMESIZE );
      strcpy( room->title, tmp );
      }

    tmp = spell_check_string( room->desc );
    if( tmp ){
      memset( room->desc, 0, RDSIZE );
      strcpy( room->desc, tmp );
      }

    for( j = 0; j < room->num_doors; j++ ){
       spell_check_door( &room->door[j] );
       }

    for( j = 0; j < room->num_exd; j++ ){
       spell_check_exd( &room->exd[j] );
       }

    return 0;
}

int spell_check_object( OBJECT *object )
{
    int j;
    char *tmp;

    tmp = spell_check_string( object->keywords );
    if( tmp ){
      memset( object->keywords, 0, NAMESIZE );
      strcpy( object->keywords, tmp );
      }

    tmp = spell_check_string( object->short_desc );
    if( tmp ){
      memset( object->short_desc, 0, NAMESIZE );
      strcpy( object->short_desc, tmp );
      }

    tmp = spell_check_string( object->long_desc );
    if( tmp ){
      memset( object->long_desc, 0, NAMESIZE );
      strcpy( object->long_desc, tmp );
      }

    tmp = spell_check_string( object->action_desc );
    if( tmp ){
      memset( object->action_desc, 0, NAMESIZE );
      strcpy( object->action_desc, tmp );
      }

    for( j = 0; j < object->num_exd; j++ ){
       spell_check_exd( &object->exd[j] );
       }

    return 0;
}

int spell_check_mobile( MOBILE *mobile )
{
    char *tmp;

    tmp = spell_check_string( mobile->keywords );
    if( tmp ){
      memset( mobile->keywords, 0, NAMESIZE );
      strcpy( mobile->keywords, tmp );
      }

    tmp = spell_check_string( mobile->short_desc );
    if( tmp ){
      memset( mobile->short_desc, 0, NAMESIZE );
      strcpy( mobile->short_desc, tmp );
      }

    tmp = spell_check_string( mobile->long_desc );
    if( tmp ){
      memset( mobile->long_desc, 0, NAMESIZE );
      strcpy( mobile->long_desc, tmp );
      }

    tmp = spell_check_string( mobile->detail_desc );
    if( tmp ){
      memset( mobile->detail_desc, 0, RDSIZE );
      strcpy( mobile->detail_desc, tmp );
      }

    return 0;
}

int spell_check_shop( SHOP *shop )
{
    shop = 0;

    return 0;
}

int spell_check_zone( ZONE *zone )
{
    int j;

    for( j = 0; j < zone->num_rooms; j++ ){
       if( spell_check_room( &zone->room[j] ) )
         return -1;
       }

    for( j = 0; j < zone->num_objects; j++ ){
       if( spell_check_object( &zone->object[j] ) )
         return -1;
       }

    for( j = 0; j < zone->num_mobiles; j++ ){
       if( spell_check_mobile( &zone->mobile[j] ) )
         return -1;
       }

    return 0;
}

int spell_check_world( WORLD *world )
{
    int j;

    mspbuf = malloc(2*RDSIZE);
    memset( mspbuf, 0, 2*RDSIZE );

    for( j = 0; j < world->num_zones; j++ ){
       if( spell_check_zone( &world->zone[j] ) ){
         free( mspbuf );
         return -1;
         }
       }

    free( mspbuf );

    return 0;
}
